/*
 * 
 *  dynamic linker command file
 *  generated: Tue May 14 22:49:41 2002

 *  kernel   : legOS
 *  app start: 0xaa22
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2a22
  ram   : o = 0xaa22, l = 0x54da
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d4 ;
    _mm_update_first_free = 0x0104 ;
    _mm_init = 0x0126 ;
    _malloc = 0x01ac ;
    _free = 0x0250 ;
    _calloc = 0x027a ;
    _mm_reaper = 0x02a2 ;
    _systime_handler = 0x02fe ;
    _systime_tm_return = 0x039a ;
    _systime_init = 0x03aa ;
    _systime_shutdown = 0x03f4 ;
    _systime_set_switcher = 0x03fc ;
    _systime_set_timeslice = 0x0402 ;
    _tm_switcher = 0x0418 ;
    _tm_scheduler = 0x0434 ;
    _yield = 0x062c ;
    _tm_init = 0x064a ;
    _tm_start = 0x068c ;
    _execi = 0x069c ;
    _exit = 0x0830 ;
    _wait_event = 0x0852 ;
    _msleep = 0x08be ;
    _sleep = 0x08e0 ;
    _kill = 0x08fe ;
    _killall = 0x093a ;
    _em_init = 0x09a8 ;
    _handle_triggers = 0x0a14 ;
    _Emachine = 0x0a88 ;
    _Einterpreter = 0x0aaa ;
    _configure_em = 0x0bae ;
    _fetch = 0x0c6a ;
    _execute = 0x0c9a ;
    _create_trigger = 0x0c9e ;
    _create_trigger_node = 0x0cde ;
    _insert = 0x0d02 ;
    _removeTriggerNode = 0x0d18 ;
    _descheduleTriggerNode = 0x0d86 ;
    _check_signal = 0x0de6 ;
    _sem_event_wait = 0x0ec4 ;
    _sem_wait = 0x0edc ;
    _sem_trywait = 0x0efc ;
    _sem_post = 0x0f14 ;
    _delay = 0x0f24 ;
    _cputc_native = 0x0f3e ;
    _cputc_native_0 = 0x0f70 ;
    _cputc_native_1 = 0x0fa8 ;
    _cputc_native_2 = 0x0fe0 ;
    _cputc_native_3 = 0x101c ;
    _cputc_native_4 = 0x1058 ;
    _cputc_native_5 = 0x1094 ;
    _cputw = 0x10a0 ;
    _cputs = 0x10e4 ;
    _cls = 0x112c ;
    _lcd_number = 0x1136 ;
    _lcd_refresh_next_byte = 0x11c8 ;
    _lcd_refresh = 0x122c ;
    _lcd_power_on = 0x125c ;
    _lcd_power_off = 0x126e ;
    _lcd_init = 0x128a ;
    _txend_handler = 0x13b2 ;
    _lnp_logical_shutdown = 0x13fc ;
    _lnp_logical_init = 0x141c ;
    _lnp_logical_write = 0x14ca ;
    _lnp_integrity_write = 0x157a ;
    _lnp_addressing_write = 0x15d2 ;
    _lnp_receive_packet = 0x164c ;
    _lnp_integrity_byte = 0x16f2 ;
    _lnp_integrity_reset = 0x17b0 ;
    _lnp_timeout_reset = 0x17ec ;
    _lnp_init = 0x17fa ;
    _lnp_integrity_active = 0x181a ;
    _lnp_timeout_set = 0x1826 ;
    _program_valid = 0x1830 ;
    _key_handler = 0x1b74 ;
    _program_init = 0x1c74 ;
    _program_shutdown = 0x1cba ;
    _vis_handler = 0x1cc2 ;
    _get_battery_mv = 0x1d26 ;
    _battery_refresh = 0x1d54 ;
    _shutoff_restart = 0x1d8e ;
    _shutoff_init = 0x1d9e ;
    _autoshutoff_check = 0x1daa ;
    _dkey_handler = 0x1dec ;
    _dkey_pressed = 0x1e2a ;
    _dkey_released = 0x1e4c ;
    _getchar = 0x1e6c ;
    _dm_handler = 0x1e96 ;
    _dm_init = 0x1ed4 ;
    _dm_shutdown = 0x1ed8 ;
    _motor_a_dir = 0x1efc ;
    _motor_b_dir = 0x1f3c ;
    _motor_c_dir = 0x1f80 ;
    _ds_rotation_set = 0x1fc8 ;
    _ds_rotation_handler = 0x2020 ;
    _ds_init = 0x2114 ;
    _ds_shutdown = 0x214a ;
    _dsound_handler = 0x2164 ;
    _dsound_init = 0x226e ;
    _dsound_shutdown = 0x2286 ;
    _dsound_stop = 0x228a ;
    _dsound_finished = 0x22aa ;
    _memset = 0x22c4 ;
    _memcpy = 0x22d2 ;
    ___mulhi3 = 0x22e4 ;
    ___modhi3 = 0x22f4 ;
    ___udivhi3 = 0x2306 ;
    ___mulsi3 = 0x2318 ;
    ___divsi3 = 0x2334 ;
    _stack_max_size = 0x2372 ;
    _eco_max_size = 0x2374 ;
    _int_max_size = 0x2376 ;
    _hex_display_codes = 0x23ba ;
    _ascii_display_codes = 0x23ca ;
    _min_length = 0x245c ;
    _dm_a_pattern = 0x246e ;
    _dm_b_pattern = 0x2472 ;
    _dm_c_pattern = 0x2476 ;
    _firmware_string = 0x2558 ;
    _etext = 0x2558 ;
    _ticks = 0x255c ;
    _pc = 0x255e ;
    _lcd_refresh_period = 0x2560 ;
    _lnp_timeout = 0x2562 ;
    _vis_refresh_counter = 0x2564 ;
    _vis_refresh_period = 0x2565 ;
    _battery_refresh_counter = 0x2566 ;
    _battery_refresh_period = 0x2568 ;
    _auto_shutoff_counter = 0x256a ;
    _auto_shutoff_period = 0x256c ;
    _auto_shutoff_secs = 0x256e ;
    _auto_shutoff_elapsed = 0x2570 ;
    _idle_powerdown = 0x2572 ;
    _dsound_system_sounds = 0x2574 ;
    __edata = 0x2576 ;
    _bss_start = 0x2580 ;
    _mm_semaphore = 0x2968 ;
    _mm_first_free = 0x296a ;
    _tm_timeslice = 0x296c ;
    _tm_current_slice = 0x296d ;
    _tm_switcher_vector = 0x296e ;
    _sys_time = 0x2970 ;
    _pd_idle = 0x2980 ;
    _cpid = 0x2982 ;
    _nb_tasks = 0x2984 ;
    _priority_head = 0x2986 ;
    _pd_single = 0x2990 ;
    _task_sem = 0x29a4 ;
    _clock_time = 0x29a8 ;
    _head = 0x29ac ;
    _em = 0x29ae ;
    _lcd_byte_counter = 0x29b0 ;
    _lcd_refresh_counter = 0x29b1 ;
    _tx_state = 0x29b2 ;
    _tx_sem = 0x29b3 ;
    _lnp_integrity_handler = 0x29c0 ;
    _lnp_timeout_counter = 0x29c2 ;
    _lnp_addressing_handler = 0x29d0 ;
    _lnp_integrity_state = 0x29f0 ;
    _packet_len = 0x29f2 ;
    _cprog = 0x29f4 ;
    _packet_src = 0x29f6 ;
    _dkey_timer = 0x29f8 ;
    _dkey = 0x29f9 ;
    _dkey_multi = 0x29fa ;
    _dm_a = 0x29fc ;
    _dm_b = 0x2a00 ;
    _dm_c = 0x2a04 ;
    _ds_rotation = 0x2a08 ;
    _ds_channel = 0x2a09 ;
    _ds_rotations = 0x2a0c ;
    _ds_activation = 0x2a12 ;
    _dsound_next_note = 0x2a14 ;
    _dsound_internote_ms = 0x2a16 ;
    _dsound_16th_ms = 0x2a18 ;
    _dsound_next_time = 0x2a1c ;
    _end = 0x2a20 ;
    _mm_start = 0x2a20 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
